var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import 'reflect-metadata';
import { DOM } from 'aurelia-pal';
var patches = newPatches();
var aureliaDialogWarningMessage = 'aurelia-dialog causes Cypress to crash. Removing plugin...';
var stylesCache = new Map();
function copyStyles(componentName) {
    var hash = componentName;
    var styles = document.querySelectorAll('head style');
    if (styles.length) {
        console.log('Injected %d styles into view', styles.length);
        stylesCache.set(hash, styles);
    }
    else {
        console.log('No styles injected for this component, checking cache...');
        var cachedStyles = stylesCache.get(hash);
        if (cachedStyles) {
            styles = cachedStyles;
        }
    }
    if (!styles) {
        return;
    }
    var parentDocument = window.parent.document;
    var projectName = Cypress.config('projectName');
    var appIframeId = "Your App: '" + projectName + "'";
    var appIframe = parentDocument.getElementById(appIframeId);
    var head = appIframe.contentDocument.querySelector('head');
    styles.forEach(function (style) {
        head.appendChild(style);
    });
}
function newPatches() {
    return {
        aureliaDialogDisabled: false
    };
}
var _ = (function () {
    function _() {
    }
    _.Patches = function () {
        return __assign({}, patches);
    };
    return _;
}());
export { _ };
var StageComponent = (function () {
    function StageComponent() {
    }
    StageComponent.withResources = function (resources) {
        if (resources === void 0) { resources = []; }
        var document = cy.state('document');
        while (document.body.firstChild) {
            document.body.removeChild(document.body.firstChild);
        }
        return new ComponentTester().withResources(resources);
    };
    return StageComponent;
}());
export { StageComponent };
var ComponentTester = (function () {
    function ComponentTester() {
        this.html = '';
        this.resources = [];
        this.bindingContext = {};
        this.configure = function (aurelia) {
            return aurelia.use.standardConfiguration();
        };
    }
    ComponentTester.prototype.withResources = function (resources) {
        if (typeof resources === 'string') {
            this.resources = [resources];
            return this;
        }
        this.resources = resources;
        return this;
    };
    ComponentTester.prototype.inView = function (html) {
        this.html = html;
        return this;
    };
    ComponentTester.prototype.boundTo = function (bindingContext) {
        this.bindingContext = bindingContext;
        return this;
    };
    ComponentTester.prototype.bootstrap = function (configure) {
        this.configure = configure;
        return this;
    };
    ComponentTester.prototype.create = function (bootstrap) {
        var _this = this;
        patches = newPatches();
        return new Cypress.Promise(function (resolve, reject) {
            var document = cy.state('document');
            return bootstrap(function (aurelia) {
                return Promise.resolve(_this.configure(aurelia)).then(function () {
                    if (_this.resources) {
                        aurelia.use.globalResources(_this.resources);
                    }
                    aurelia.container.registerInstance(Element, document.createElement);
                    aurelia.container.registerInstance(DOM.Element, document.createElement);
                    {
                        var plugins = aurelia.use.info;
                        if (plugins) {
                            plugins = plugins.filter(function (plugin) {
                                if (plugin &&
                                    plugin.moduleId &&
                                    plugin.moduleId === 'aurelia-dialog') {
                                    console.warn(aureliaDialogWarningMessage);
                                    patches.aureliaDialogDisabled = true;
                                    return false;
                                }
                                return true;
                            });
                            aurelia.use.info = plugins;
                        }
                    }
                    return aurelia.start().then(function () {
                        if (document.activeElement !== document.body) {
                            document.body.focus();
                        }
                        while (document.body.firstChild) {
                            document.body.removeChild(document.body.firstChild);
                        }
                        document.body.innerHTML = _this.html;
                        var bindingContext = _this.bindingContext;
                        return aurelia.enhance(bindingContext, document.body).then(function () {
                            copyStyles(_this.resources.join(','));
                            window.requestAnimationFrame(function () {
                                window.requestAnimationFrame(function () {
                                    window.requestAnimationFrame(function () {
                                        window.requestAnimationFrame(function () {
                                            resolve();
                                        });
                                    });
                                });
                            });
                        });
                    }).catch(function (err) {
                        reject(err);
                        return;
                    });
                });
            });
        });
    };
    return ComponentTester;
}());
export { ComponentTester };
