"use strict";
function copyEventHandlesFromSpecIFrameToAppIFrame() {
    var specIframe = window.parent.document.querySelector('iframe.spec-iframe');
    if (!specIframe) {
        throw new Error('Cannot find .spec-iframe');
    }
    var specDocument = specIframe.contentDocument;
    if (!specDocument) {
        throw new Error('Cannot find contentDocument on specIframe');
    }
    var rootDocument = window.parent.document;
    var appIframe = rootDocument.querySelector('iframe.aut-iframe');
    if (!appIframe) {
        throw new Error('Cannot find .aut-iframe');
    }
    var appDocument = appIframe.contentDocument;
    if (!appDocument) {
        throw new Error('Cannot find contentDocument on appIframe');
    }
    var originalEventListener = specDocument.addEventListener;
    var addEventListener = function () {
        originalEventListener.apply(this, arguments);
        appDocument.addEventListener.apply(appDocument, arguments);
    };
    if (specDocument.addEventListener !== addEventListener) {
        specDocument.addEventListener = addEventListener;
    }
}
before(copyEventHandlesFromSpecIFrameToAppIFrame);
